----------------------------------------------------------
--This module selects either the highpass or the lowpass--
--filter based on input from switch 16 on the DE2 board---
----------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity filter_select is
port(
	clk,SW16,reset : in std_logic;
	highpass,lowpass: out std_logic
);
end entity filter_select;

architecture structure of filter_select is
begin
	functionality : process(clk,reset) 
	begin
		if(rising_edge(clk)) then
			if(reset = '0') then --Active low reset
				highpass <= '0';
				lowpass <= '0';
			elsif(SW16 = '0' and reset = '1') then --Select lowpass
				highpass <= '0';
				lowpass <= '1';			
			elsif(SW16 = '1' and reset = '1') then --Select highpass
				highpass <= '1';
				lowpass <= '0';	
			else
				highpass <= '0';
				lowpass <= '0';
			end if;
		end if;
	end process;
end architecture;