-- Copyright (C) 1991-2010 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 9.1 Build 304 01/25/2010 Service Pack 1 SJ Web Edition"
-- CREATED		"Thu Apr 22 10:26:10 2010"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY in_out_test IS 
	PORT
	(
		AUD_ADCDAT :  IN  STD_LOGIC;
		AUD_ADCLRCK :  IN  STD_LOGIC;
		AUD_DACLRCK :  IN  STD_LOGIC;
		AUD_BCLK :  IN  STD_LOGIC;
		SW :  IN  STD_LOGIC_VECTOR(9 TO 9);
		AUD_DACDAT :  OUT  STD_LOGIC
	);
END in_out_test;

ARCHITECTURE bdf_type OF in_out_test IS 

COMPONENT audio_buffer_out
	PORT(clk : IN STD_LOGIC;
		 data_ready : IN STD_LOGIC;
		 lrc : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 fifo_empty : IN STD_LOGIC;
		 audio_data_in : IN STD_LOGIC_VECTOR(23 DOWNTO 0);
		 dac_data : OUT STD_LOGIC;
		 read_req : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT audio_buffer
	PORT(clk : IN STD_LOGIC;
		 adc_data : IN STD_LOGIC;
		 lrc : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 eop : OUT STD_LOGIC;
		 write_req : OUT STD_LOGIC;
		 filter_data : OUT STD_LOGIC_VECTOR(24 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	ADCDAT :  STD_LOGIC;
SIGNAL	ADCLRC :  STD_LOGIC;
SIGNAL	BCLK :  STD_LOGIC;
SIGNAL	DACDAT :  STD_LOGIC;
SIGNAL	DACLRC :  STD_LOGIC;
SIGNAL	DATA :  STD_LOGIC_VECTOR(24 DOWNTO 0);
SIGNAL	eop :  STD_LOGIC;
SIGNAL	FIFO_EMPTY :  STD_LOGIC;
SIGNAL	READ_REQ :  STD_LOGIC;
SIGNAL	reset_n :  STD_LOGIC;
SIGNAL	WRITE_REQ :  STD_LOGIC;


BEGIN 



b2v_inst10 : audio_buffer_out
PORT MAP(clk => BCLK,
		 data_ready => DATA(24),
		 lrc => DACLRC,
		 reset => reset_n,
		 fifo_empty => FIFO_EMPTY,
		 audio_data_in => DATA(23 DOWNTO 0),
		 dac_data => DACDAT);


b2v_inst7 : audio_buffer
PORT MAP(clk => BCLK,
		 adc_data => ADCDAT,
		 lrc => ADCLRC,
		 reset => reset_n,
		 filter_data => DATA);

AUD_DACDAT <= DACDAT;
BCLK <= AUD_BCLK;
ADCDAT <= AUD_ADCDAT;
ADCLRC <= AUD_ADCLRCK;
reset_n <= SW(9);
DACLRC <= AUD_DACLRCK;

END bdf_type;